export const namespace = 'feedbackSearchOptions'

export const feedbackSearchOptsMut = Object.freeze({
  SET_SHOW_FINAL: 'SET_SHOW_FINAL',
  SET_SEARCH_OTHER_USER_COMMENTS: 'SET_SEARCH_OTHER_USER_COMMENTS',
  SET_CASE_SENSITIVE: 'SET_CASE_SENSITIVE',
  SET_USE_REGEX: 'SET_USE_REGEX'
})

function initialState () {
  return {
    showFinal: false,
    searchOtherUserComments: false,
    caseSensitive: false,
    useRegex: false
  }
}

const feedbackSearchOptions = {
  namespaced: true,
  state: initialState(),
  getters: {
    regex: state => RegExp(state.regexStr)
  },
  mutations: {
    [feedbackSearchOptsMut.SET_SHOW_FINAL]: (state, val) => { state.showFinal = val },
    [feedbackSearchOptsMut.SET_SEARCH_OTHER_USER_COMMENTS]: (state, val) => {
      state.searchOtherUserComments = val
    },
    [feedbackSearchOptsMut.SET_CASE_SENSITIVE]: (state, val) => { state.caseSensitive = val },
    [feedbackSearchOptsMut.SET_USE_REGEX]: (state, val) => { state.useRegex = val }
  }
}

export default feedbackSearchOptions
